using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace MvcMovie
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            //tu dopisane !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            /*
            routes.MapRoute(
                "ByGenre", //Nazwa ścieżki
                "Movies/{Genre}", //Ścieżka sztywna /Movies/ i parametr Genre
                new { controller = "Movies", action = "ShowCategory" }
            );
            */
            /*
            routes.MapRoute(
                "ByGenre", //Nazwa ścieżki
                "Movies/{Genre}/{Age}", //Ścieżka sztywna /Movies/ i parametr Genre
                new { controller = "Movies", action = "ShowCategory", Age=UrlParameter.Optional } //Age = wiek osoby ogladajacej
            );
            */
            routes.MapRoute(
                "ByGenre", //Nazwa ścieżki
                "Movies/{Genre}/{Age}", //Ścieżka sztywna /Movies/ i parametr Genre
                new { controller = "Movies", action = "ShowCategory" }, new { Age = @"\d+" } //już nie opcjonalny, ale wymuszony w podanym formacie
            );

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                //new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
                new { controller = "Movies", action = "Index", id = UrlParameter.Optional } // tu zmieniona strona domyślna !!!!
            );
        }

        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
        }
    }
}